﻿/*
 * Vytvořeno aplikací SharpDevelop.
 * Uživatel: bauer
 * Datum: 3.11.2009
 * Čas: 11:06
 * 
 * Tento template můžete změnit pomocí Nástroje | Možnosti | Psaní kódu | Upravit standardní hlavičky souborů.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.Runtime.InteropServices;

using System.Collections.Generic;

namespace nameUSB2CAN
{


  public class USB2CAN {


    
    [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Unicode)]
    public struct CAN_MESSAGE {
      [FieldOffset(0)]
      public UInt16 Id1;     //unsigned __int16 Id1; nevim proc, ale jsou to 4 byty
      [FieldOffset(4)]
      public UInt32 Id2;     //unsigned __int32 Id2;
      [FieldOffset(8)]
      public UInt32 Id;      //unsigned __int32 Id;
      [FieldOffset(12)]
      public byte length;    //unsigned char length;
      [FieldOffset(13)]
      public bool rtr;       //bool
      [FieldOffset(14)]
      public bool st_ext;    //bool
      //message data
      [FieldOffset(15)]
      public byte data0;     // unsigned char data[8];
      [FieldOffset(16)]
      public byte data1;
      [FieldOffset(17)]
      public byte data2;
      [FieldOffset(18)]
      public byte data3;
      [FieldOffset(19)]
      public byte data4;
      [FieldOffset(20)]
      public byte data5;
      [FieldOffset(21)]
      public byte data6;
      [FieldOffset(22)]
      public byte data7;
      //CANMessageTime
      [FieldOffset(23)]
      public UInt16 Hour;          //unsigned short
      [FieldOffset(25)]
      public UInt16 Minute;        //unsigned short
      [FieldOffset(27)]
      public UInt16 Second;        //unsigned short
      [FieldOffset(29)]
      public UInt16 Milliseconds;  //unsigned short
      [FieldOffset(31)]
      public UInt32 TimeStampUS;   //unsigned short                        
    }
   /* public struct CAN_MSG {
     public UInt32 Id;
     public byte lenght;
     public byte data0;
     public byte data1;
     public byte data2;
     public byte data3;
     public byte data4;
     public byte data5;
     public byte data6;
     public byte data7;

    }*/
    private enum EUSB2CANDevice {
      OPEN_BY_DEVICE_NUMBER = 0,
      OPEN_BY_SERIAL_NUMBER,
      OPEN_BY_DESCRIPTION

    }

    public enum CAN_SPEED {
      SPEED_10k = 10,
      SPEED_20k = 20,
      SPEED_33_3k = 33,
      SPEED_50k = 50,
      SPEED_62_5k = 62,
      SPEED_83_3k = 83,
      SPEED_100k = 100,
      SPEED_125k = 125,
      SPEED_250k = 250,
      SPEED_500k = 500,
      SPEED_1M = 1000,
      SPEED_USR = 0
    }
    public enum CAN_LH_SPEED {
      LOW_SPEED = 0,
      HIHGT_SPEED = 1
    }
    public enum CAN_MSG_TYP {
      STANDART = 0,
      EXTENDED = 1
    }


    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_PrepareAdapter", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_PrepareAdapter();
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_PrepareAdapterEx", CallingConvention = CallingConvention.StdCall)]
    private static extern IntPtr USB2CAN_PrepareAdapterEx(EUSB2CANDevice selector, string lgName);
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_SelectActualAdapter", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_SelectActualAdapter(IntPtr adapter);
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_Open", CallingConvention = CallingConvention.Winapi)]
    private static extern bool USB2CAN_Open(CAN_SPEED speed, bool CreateCommThreads, IntPtr error_function, bool LowSpeed);
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_Close", CallingConvention = CallingConvention.Winapi)]
    private static extern bool USB2CAN_Close();
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_GetUSBDeviceInfo", CallingConvention = CallingConvention.Winapi)]
    private static extern string USB2CAN_GetUSBDeviceInfo();
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_GetCANMessage", CallingConvention = CallingConvention.StdCall)]
    private static extern bool USB2CAN_GetCANMessage(ref CAN_MESSAGE message);
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_GetRXBufferLength", CallingConvention = CallingConvention.StdCall)]
    private static extern int USB2CAN_GetRXBufferLength();
    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_GetTXBufferLength", CallingConvention = CallingConvention.StdCall)]
    private static extern int USB2CAN_GetTXBufferLength();

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_SendCANMessage", CallingConvention = CallingConvention.StdCall)]
    private static extern bool USB2CAN_SendCANMessage(CAN_MESSAGE message);

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_DestroyAdapter", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_DestroyAdapter(IntPtr adapter);

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_EnableReadTEC", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_EnableReadTEC(ref bool enable);

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_EnableReadREC", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_EnableReadREC(ref bool enable);

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_GetREC", CallingConvention = CallingConvention.StdCall)]
    private static extern byte USB2CAN_GetREC();

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_GetTEC", CallingConvention = CallingConvention.StdCall)]
    private static extern byte USB2CAN_GetTEC();

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_ClearBuffers", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_ClearBuffers();

    [DllImport(@"..\\knihovny\\x2can_c_dll.dll", EntryPoint = "USB2CAN_SetTimeStampMode", CallingConvention = CallingConvention.StdCall)]
    private static extern void USB2CAN_SetTimeStampMode(bool mode);


    private IntPtr li_Adapter_1; 
    /// <summary>
    /// inicializuje CAN zarizeni
    /// </summary>
    /// <param name="speedCAN"> speed communication</param>
    /// <param name="speedWIRE"> physical layers </param>
    /// <returns></returns>
    public bool CAN_INIT(CAN_SPEED speedCAN, CAN_LH_SPEED speedWIRE ) {
      bool result; 
      li_Adapter_1 = USB2CAN_PrepareAdapterEx(EUSB2CANDevice.OPEN_BY_DEVICE_NUMBER, "0");
      USB2CAN_SelectActualAdapter(li_Adapter_1);

      switch (speedWIRE) {
        case CAN_LH_SPEED.LOW_SPEED: result = USB2CAN_Open(speedCAN, true, IntPtr.Zero, true); break;
        default: result = USB2CAN_Open(speedCAN, true, IntPtr.Zero, false); break;
      }
      return result;
    }
    /// <summary>
    /// zasila zpravy na CAN
    /// </summary>
    /// <param name="msg">zprava</param>
    /// <param name="typ">STANDART nebo EXTENDED zprava</param>
    /// <returns></returns>
    public bool SEND_CAN_MESSAGE(CAN_MESSAGE msg,CAN_MSG_TYP typ) {     

      DateTime CurrTime = DateTime.Now;
      bool result;
      CAN_MESSAGE message = new CAN_MESSAGE();
      if (typ == CAN_MSG_TYP.STANDART) {
        message.Id1 = Convert.ToUInt16(msg.Id & 0x7FF);
        message.Id2 = 0;
      } else {
        message.Id1 = Convert.ToUInt16(msg.Id & 0x7FF);
        message.Id2 = Convert.ToUInt16(msg.Id>>18);
      }
      message.data0 = msg.data0;
      message.data1 = msg.data1;
      message.data2 = msg.data2;
      message.data3 = msg.data3;
      message.data4 = msg.data4;
      message.data5 = msg.data5;
      message.data6 = msg.data6;
      message.data7 = msg.data7;
      message.Hour = Convert.ToUInt16(CurrTime.Hour);
      message.Minute = Convert.ToUInt16(CurrTime.Minute);
      message.Milliseconds = Convert.ToUInt16(CurrTime.Millisecond);
      message.TimeStampUS = 0;
      if (message.length > 8) message.length = 8;
      message.length = msg.length;
      switch (typ){
        case CAN_MSG_TYP.STANDART: message.st_ext = false; break;
        case CAN_MSG_TYP.EXTENDED: message.st_ext = true; break;
      }
      result = USB2CAN_SendCANMessage(message);
      return result;
    }
    /// <summary>
    /// Vraci datovy typ message se zpravou z prevodniku
    /// </summary>
    /// <returns></returns>
   public CAN_MESSAGE GET_CAN_MESSAGE() {
      CAN_MESSAGE msg = new CAN_MESSAGE();
      bool result;
      result = USB2CAN_GetCANMessage(ref msg);
      if (result == false) msg.length = 0;
      return msg; 
    }
    /// <summary>
    /// Vraci pocet prijatych zprav
    /// </summary>
    /// <returns></returns>
    public int GET_RX_BUF(){
      return USB2CAN_GetRXBufferLength();
    }
    /// <summary>
    /// zapina cteni TEC
    /// </summary>
    /// <returns>true pokud uspech</returns>
    public bool ENABLE_READ_TEC() {
      bool enabled = new bool(); 
      USB2CAN_EnableReadTEC(ref enabled);
      return enabled;

    }
    /// <summary>
    /// zapina cteni REC
    /// </summary>
    /// <returns>true pokud uspech</returns>
    public bool ENABLE_READ_REC() {
      bool enabled = new bool();
      USB2CAN_EnableReadREC(ref enabled);
      return enabled;

    }
    /// <summary>
    /// vraci hodnotu v REC registru
    /// </summary>
    /// <returns></returns>
    public uint GET_REC() {
      return USB2CAN_GetREC();
    }
    /// <summary>
    /// vraci hodnotu v TEC registru
    /// </summary>
    /// <returns></returns>
    public uint GET_TEC() {
      return USB2CAN_GetTEC();
    }
    /// <summary>
    /// Vymaze buffer zarizeni
    /// </summary>
    public void CLEAR_BUFFERS() {
      USB2CAN_ClearBuffers();
    }

    /// <summary>
    /// Uzavyra spojeni s adapterem 
    /// </summary>
    /// <returns></returns>
    public bool CONECTION_CLOSE() {
      bool result;

      result = USB2CAN_Close();
      if (result){
        USB2CAN_DestroyAdapter(li_Adapter_1);
      }
      return result;

    }
    /// <summary>
    /// Povoluje mereni casu prijeti zpravy 
    /// </summary>
    /// <param name="mode"></param>
    public void SET_TIMESTAMP_MODE(bool mode) {
      USB2CAN_SetTimeStampMode(mode);
    }

    /// <summary>
    /// Konvertuje retezec hex na typ byte
    /// </summary>
    /// <param name="HEX">pr:"0x1F" , nebo "1F"</param>
    /// <returns></returns>
    public byte HEX_TO_BYTE(string HEX) { 
      byte retByte;
      try {
        HEX = HEX.Trim();
        retByte = Convert.ToByte(HEX, 16);
      } catch {
        retByte = 0;
      }
      return retByte;
    }
    public Int32 HEX_TO_INT32(string HEX) {
      Int32 retByte;
      try {
        HEX = HEX.Trim();
        retByte = Convert.ToInt32(HEX, 16);
      } catch {
        retByte = 0;
      }
      return retByte;

    }



  }
}
