﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using nameUSB2CAN;
using System.Threading;
using System.Globalization;

namespace nameForm {
  public partial class Form1: Form {

    public USB2CAN usb2can;
    public Thread thrREAD;
    public Thread thrWRITE;
    public long cntMESSAGE;
    long cntMESSAGE_TX;
    public bool runWRITER;
    public bool runREADER,reader_BUSSY;
    public bool adapter_OPEN;
    string txtDATAHEX;
    
    public Form1() {
      InitializeComponent();
      // inicializace promennych

      usb2can = new USB2CAN();
      thrREAD = new Thread(new ThreadStart(USB_READ_LISTENER));
      thrWRITE = new Thread(new ThreadStart(USB_WRITE_LISTENER));
      reader_BUSSY = false;
      runWRITER = false;
      runREADER = false;
      adapter_OPEN = false;
      // start dvou vlaken, jedno pro cteni a druhe pro zapis do USB zarizeni
      thrREAD.Start();
      thrWRITE.Start();

      cmbSPEED.SelectedIndex = 7;

    }

    private void Form1_Load(object sender, EventArgs e) {
    }

    private void btn_INIT_Click(object sender, EventArgs e) {
      //inicializace USB zarizeni
      USB2CAN.CAN_SPEED speed;
      USB2CAN.CAN_LH_SPEED typ;

      switch (cmbSPEED.SelectedIndex) {
        case 0: speed = USB2CAN.CAN_SPEED.SPEED_10k; break;
        case 1: speed = USB2CAN.CAN_SPEED.SPEED_20k; break;
        case 2: speed = USB2CAN.CAN_SPEED.SPEED_33_3k; break;
        case 3: speed = USB2CAN.CAN_SPEED.SPEED_50k; break;
        case 4: speed = USB2CAN.CAN_SPEED.SPEED_62_5k; break;
        case 5: speed = USB2CAN.CAN_SPEED.SPEED_83_3k; break;
        case 6: speed = USB2CAN.CAN_SPEED.SPEED_100k; break;
        case 7: speed = USB2CAN.CAN_SPEED.SPEED_125k; break;
        case 8: speed = USB2CAN.CAN_SPEED.SPEED_250k; break;
        case 9: speed = USB2CAN.CAN_SPEED.SPEED_500k; break;
        case 10: speed = USB2CAN.CAN_SPEED.SPEED_1M; break;
        default: speed = USB2CAN.CAN_SPEED.SPEED_250k; break;
      }
      if (rbHIGHT.Checked) typ = USB2CAN.CAN_LH_SPEED.HIHGT_SPEED;
      else typ = USB2CAN.CAN_LH_SPEED.LOW_SPEED;

      bool result = usb2can.CAN_INIT(speed,typ);
      if (result) {

        adapter_OPEN = true;
        btn_INIT.Enabled = false;
        btn_CLOSECON.Enabled = true;
        btn_START.Enabled = true;

        usb2can.ENABLE_READ_TEC();
        usb2can.ENABLE_READ_REC();
        usb2can.SET_TIMESTAMP_MODE(true);

      }

    }

    private void SEND_message() {
      // poslani can zpravy
      USB2CAN.CAN_MESSAGE message = new USB2CAN.CAN_MESSAGE();
      USB2CAN.CAN_MSG_TYP typ = new USB2CAN.CAN_MSG_TYP(); 
      byte[] MSGdata = new byte[8] { 0, 0, 0, 0, 0, 0, 0, 0 };
      string[] data = new string[8] { "0", "0", "0", "0", "0", "0", "0", "0" };
        try {

          

          data = txtDATAHEX.Split(',');
          message.length = Convert.ToByte(data.Length);

          for (int i = 0; i < data.Length; i++) {
            MSGdata[i] = usb2can.HEX_TO_BYTE(data[i]);
          }

          message.Id = Convert.ToUInt32(usb2can.HEX_TO_INT32(txtID.Text.Trim()));
          message.data0 = MSGdata[0];
          message.data1 = MSGdata[1];
          message.data2 = MSGdata[2];
          message.data3 = MSGdata[3];
          message.data4 = MSGdata[4];
          message.data5 = MSGdata[5];
          message.data6 = MSGdata[6];
          message.data7 = MSGdata[7];


          if (rbTYPA.Checked) {
            typ = USB2CAN.CAN_MSG_TYP.STANDART;
          } else {
            typ = USB2CAN.CAN_MSG_TYP.EXTENDED;
          }
          usb2can.SEND_CAN_MESSAGE(message, typ);
          cntMESSAGE++;
          if (tableCANDATA.Rows.Count > 19) tableCANDATA.Clear();
          DataRow row = tableCANDATA.NewRow();
          row["LINE"] = cntMESSAGE.ToString();
          row["TIME"] = String.Format("{0:D2}:{1:D2}:{2:D2}: {3:D5}", DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second, DateTime.Now.Millisecond);
          row["ID"] = Convert.ToString(message.Id, 16);
          row["DIR"] = "Tx";
          row["DATA"] = String.Format("{0} , {1} , {2} , {3} , {4} , {5} , {6} , {7}"
            , message.data0.ToString("X2")
            , message.data1.ToString("X2")
            , message.data2.ToString("X2")
            , message.data3.ToString("X2")
            , message.data4.ToString("X2")
            , message.data5.ToString("X2")
            , message.data6.ToString("X2")
            , message.data7.ToString("X2"));

          tableCANDATA.Rows.Add(row);

        } catch {

      }
    }

    private void btn_CLOSECON_Click(object sender, EventArgs e) {

      if (adapter_OPEN) {
        runWRITER = false;
        runREADER = false;

        usb2can.CONECTION_CLOSE();
        adapter_OPEN = false;

        btn_START.Enabled = false;
        btn_STOP.Enabled = false;
        btn_CLEAR.Enabled = false;
        btn_CLOSECON.Enabled = false;
        btn_SEND.Enabled = false;

        btn_INIT.Enabled = true;
      }

    }
    private void USB_READ_LISTENER() {
      USB2CAN.CAN_MESSAGE msg = new USB2CAN.CAN_MESSAGE();
      DataRow row;

      while (thrREAD.IsAlive) {        
        while (runREADER) {
          reader_BUSSY = true;
          int numMSG = usb2can.GET_RX_BUF();
          if (numMSG > 0) {
            for (int i = 0; i < numMSG; i++) {

              if (!runREADER) break;
              msg = usb2can.GET_CAN_MESSAGE();
              if (msg.length > 0) {

                cntMESSAGE++;
                if (tableCANDATA.Rows.Count > 19) tableCANDATA.Clear();

                row = tableCANDATA.NewRow();
                row["LINE"] = cntMESSAGE.ToString();
                row["TIME"] = String.Format("{0:D2}:{1:D2}:{2:D2}: {3:D5}", DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second, msg.Milliseconds);
                row["ID"] = Convert.ToString(msg.Id, 16);
                row["DIR"] = "Rx";
                row["DATA"] = String.Format("{0} , {1} , {2} , {3} , {4} , {5} , {6} , {7}"
                  , msg.data0.ToString("X2")
                  , msg.data1.ToString("X2")
                  , msg.data2.ToString("X2")
                  , msg.data3.ToString("X2")
                  , msg.data4.ToString("X2")
                  , msg.data5.ToString("X2")
                  , msg.data6.ToString("X2")
                  , msg.data7.ToString("X2"));
                tableCANDATA.Rows.Add(row);

                Thread.Sleep(50);

                if (runREADER) {
                  lb_REC.Invoke((new MethodInvoker(delegate { lb_REC.Text = usb2can.GET_REC().ToString(); })));
                  lb_TEC.Invoke((new MethodInvoker(delegate { lb_TEC.Text = usb2can.GET_TEC().ToString(); })));
                  lb_COUNT_RX.Invoke((new MethodInvoker(delegate { lb_COUNT_RX.Text = cntMESSAGE.ToString(); })));
                } 
              }
            }
          }
        }
        reader_BUSSY = false;
        Thread.Sleep(100);
      }
    }

    private void USB_WRITE_LISTENER() {
      int timer;
      
      while (thrWRITE.IsAlive) {
        if (runWRITER) {
          try {
            if (chb_REPEAT.Checked) {
              timer = Convert.ToInt16(txtTIME.Text);
              if (timer < 0) timer = 1;
              if (timer > 10000) timer = 10000;
            }
            while (true) {
              if (runWRITER) {
                SEND_message();
                cntMESSAGE_TX++;
                lb_COUNT_TX.Invoke((new MethodInvoker(delegate { lb_COUNT_TX.Text = cntMESSAGE_TX.ToString(); })));
              } 
              if (!chb_REPEAT.Checked || !runWRITER) break;
              Thread.Sleep(Convert.ToInt16(txtTIME.Text));
            }
            runWRITER = false;
          } catch {
          }

        }
        Thread.Sleep(100);
      }
    }

    private void btn_CLEAR_Click(object sender, EventArgs e) {
      cntMESSAGE = 0;
      cntMESSAGE_TX = 0;
      lb_REC.Text = "0";
      lb_TEC.Text = "0";
      lb_COUNT_RX.Text = "0";
      lb_COUNT_TX.Text = "0";

      usb2can.CLEAR_BUFFERS();
      tableCANDATA.Clear();

    }

    private void btn_SEND_Click(object sender, EventArgs e) {
       
       txtDATAHEX = txtDATA.Text.Trim();
       runWRITER = true;

    }

    private void Form1_FormClosing(object sender, FormClosingEventArgs e) {
      if (adapter_OPEN) {
        runWRITER = false;
        usb2can.CONECTION_CLOSE();
        adapter_OPEN = false;
      }
      thrREAD.Abort();
      thrWRITE.Abort();

    }

    private void btn_START_Click(object sender, EventArgs e) {
      runREADER = true;
      btn_SEND.Enabled = true;
      btn_CLEAR.Enabled = true;
      btn_STOP.Enabled = true;
      btn_START.Enabled = false;

    }

    private void btn_STOP_Click(object sender, EventArgs e) {
      runREADER = false;
      runWRITER = false;

      btn_SEND.Enabled = false;
      btn_CLEAR.Enabled = false;
      btn_STOP.Enabled = false;
      btn_START.Enabled = true;

    }

    private void cmbSPEED_SelectedIndexChanged(object sender, EventArgs e) {
      if (cmbSPEED.SelectedIndex > 7 && rbLOW.Checked) cmbSPEED.SelectedIndex = 7;
    }

    private void rbLOW_CheckedChanged(object sender, EventArgs e) {
      if (cmbSPEED.SelectedIndex > 7 && rbLOW.Checked) cmbSPEED.SelectedIndex = 7;
    }


  
  }
}
